#!/bin/bash

# do not run

basedir=`dirname $0`
basedir=`readlink -f $basedir/../`
cd $basedir || exit 1

version=`head -n1 VERSION`
name=ecaml
tar=$name-$version.tar.gz
tar_dst=$HOME/htdocs/src/$name
chroot_dir=/home/komar/chroot/squeeze-x86
chroot_dist_dir=/home/komar/$name
user=komar
ecaml_name=$name-bin-x86-$version

function release_sources {
  darcs dist -d $name-$version || exit 1
  cp $tar $tar_dst || exit 1
  make -s clean || exit 1
}

function release_ecaml {
  cd $chroot_dist_dir || exit 1
  make -s clean || exit 1
  make -s -j4 ${name} || exit 1
  #strip --strip-unneeded ${name} || exit 1
  mkdir -p $ecaml_name
  mv ${name} $ecaml_name || exit 1
  tar -cf $ecaml_name.tar.gz $ecaml_name || exit 1
  make -s clean || exit 1
  rm -r $ecaml_name
  exit
}

case "$1" in
  sources) release_sources;;
  ecaml-root) su -c "$0 ecaml" $user;;
  ecaml) release_ecaml;;
  *) $0 sources &&
    rm -rf $chroot_dir/$chroot_dist_dir &&
    darcs put --no-set-default $chroot_dir/$chroot_dist_dir &&
    chmod +x $chroot_dir/$chroot_dist_dir/devel/release.bash &&
    sudo chroot $chroot_dir $chroot_dist_dir/devel/release.bash ecaml-root;
    mkdir -p $tar_dst/bin/;
    cp $chroot_dir/$chroot_dist_dir/$ecaml_name.tar.gz $tar_dst/bin/;;
esac

